var __awaiter =
    (this && this.__awaiter) ||
    function(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function(resolve, reject) {
            function fulfilled(value) {
                try {
                    step(generator.next(value));
                } catch (e) {
                    reject(e);
                }
            }
            function rejected(value) {
                try {
                    step(generator["throw"](value));
                } catch (e) {
                    reject(e);
                }
            }
            function step(result) {
                result.done
                    ? resolve(result.value)
                    : new P(function(resolve) {
                          resolve(result.value);
                      }).then(fulfilled, rejected);
            }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    };
var __generator =
    (this && this.__generator) ||
    function(thisArg, body) {
        var _ = {
                label: 0,
                sent: function() {
                    if (t[0] & 1) throw t[1];
                    return t[1];
                },
                trys: [],
                ops: []
            },
            f,
            y,
            t,
            g;
        return (g = { next: verb(0), throw: verb(1), return: verb(2) }), typeof Symbol === "function" &&
            (g[Symbol.iterator] = function() {
                return this;
            }), g;
        function verb(n) {
            return function(v) {
                return step([n, v]);
            };
        }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (((f = 1), y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done)) return t;
                    if (((y = 0), t)) op = [0, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!((t = _.trys), (t = t.length > 0 && t[t.length - 1])) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2]) _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                } catch (e) {
                    op = [6, e];
                    y = 0;
                } finally {
                    f = t = 0;
                }
            if (op[0] & 5) throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    };
Object.defineProperty(exports, "__esModule", { value: true });
var chokidar = require("chokidar");
var child_process_1 = require("child_process");
var cp = require("child-process-es6-promise");
var chalk = require("chalk");
var moment = require("moment");
var emoji = require("node-emoji");
console.reset = function() {
    return process.stdout.write("\033c");
};
var Mapi = (function() {
    function Mapi() {
        this.Err = [];
        this.Times = [];
    }
    Mapi.prototype.sayHi = function() {
        console.log("hi from Mapi");
    };
    Mapi.prototype.parse = function(stdout) {
        var forParse = stdout;
        var m;
        var regex = /@@\s(\+|-)[0-9]*(?:,)?(?:[0-9]*)?\s(\+|-)[0-9]*(?:,)?(?:[0-9]*)?/gi;
        var f = [];
        while ((m = regex.exec(forParse)) !== null) {
            if (m.index === regex.lastIndex) {
                regex.lastIndex++;
            }
            m.forEach(function(match, groupIndex) {
                if (groupIndex == 0) {
                    var modify = match.replace("@@", "");
                    f.push(modify);
                }
            });
        }
        var commitComment = f.join(" ");
        return commitComment;
    };
    Mapi.prototype.deleteCommit = function(path) {
        child_process_1.exec('git commit -m "deleted" ' + path);
    };
    Mapi.prototype.commitFile = function(path, comment) {
        return __awaiter(this, void 0, void 0, function() {
            var stdout, t, error_1;
            return __generator(this, function(_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, cp.spawn("git", ["commit", "-m", '"' + comment + '"', path])];
                    case 1:
                        stdout = _a.sent().stdout;
                        t = moment().format();
                        this.Times.push({ t: t });
                        console.reset();
                        console.log(
                            "\n  ",
                            chalk.green(emoji.emojify(":black_circle:")),
                            " ",
                            chalk.white.underline.bold("Working - " + this.Times.length + " has been commited"),
                            " ",
                            chalk.red(emoji.emojify(":heavy_multiplication_x:")),
                            " ",
                            !this.Err.length
                                ? chalk.white.underline.bold("Catched errors " + this.Err.length)
                                : chalk.red.underline.bold("Catched errors " + this.Err.length)
                        );
                        this.Times.map(function(val, index) {
                            console.log(
                                "\n  ",
                                emoji.emojify(":heavy_check_mark:"),
                                chalk.green(" " + path),
                                " ",
                                "[" + comment.replace(/\s/g, "") + "]",
                                " ",
                                moment(val.t).fromNow()
                            );
                        });
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _a.sent();
                        this.Err.push(error_1);
                        return [3 /*break*/, 3];
                    case 3:
                        return [2 /*return*/];
                }
            });
        });
    };
    //exec(`git commit -m "${comment}" ${path}`);
    Mapi.prototype.diff = function(path) {
        return __awaiter(this, void 0, void 0, function() {
            var stdout, comment, gc;
            return __generator(this, function(_a) {
                switch (_a.label) {
                    case 0:
                        return [4 /*yield*/, cp.spawn("git", ["diff", "-U0", path])];
                    case 1:
                        stdout = _a.sent().stdout;
                        return [4 /*yield*/, this.parse(stdout)];
                    case 2:
                        comment = _a.sent();
                        return [4 /*yield*/, this.commitFile(path, comment)];
                    case 3:
                        gc = _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Mapi.prototype.start = function() {
        var _this = this;
        console.reset();
        var watcher = chokidar.watch(".", { ignored: /(node_modules|.git)/ });
        watcher
            .on("add", function(path) {
                return child_process_1.exec("git add " + path);
            })
            .on("change", function(path) {
                return _this.diff(path);
            })
            .on("unlink", function(path) {
                return _this.deleteCommit(path);
            });
    };
    return Mapi;
})();
exports.default = Mapi;
// const menma = new Menma();
// menma.start();
